"""
..

Search filters.
===============

"""

from enum import Enum

class Languages(Enum):
    """Available languages."""

    Any = ""
    Afrikaans = "lang_af"
    Arabic = "lang_ar"
    Armenian = "lang_hy"
    Belarusian = "lang_be"
    Bulgarian = "lang_bg"
    Catalan = "lang_ca"
    ChineseSimplified = "lang_zh-CN"
    ChineseTraditional = "lang_zh-TW"
    Croatian = "lang_hr"
    Czech = "lang_cs"
    Danish = "lang_da"
    Dutch = "lang_nl"
    English = "lang_en"
    Esperanto = "lang_eo"
    Estonian = "lang_et"
    Filipino = "lang_tl"
    Finnish = "lang_fi"
    French = "lang_fr"
    German = "lang_de"
    Greek = "lang_el"
    Hebrew = "lang_iw"
    Hindi = "lang_hi"
    Hungarian = "lang_hu"
    Icelandic = "lang_is"
    Indonesian = "lang_id"
    Italian = "lang_it"
    Japanese = "lang_ja"
    Korean = "lang_ko"
    Latvian = "lang_lv"
    Lithuanian = "lang_lt"
    Norwegian = "lang_no"
    Persian = "lang_fa"
    Polish = "lang_pl"
    Portuguese = "lang_pt"
    Romanian = "lang_ro"
    Russian = "lang_ru"
    Serbian = "lang_sr"
    Slovak = "lang_sk"
    Slovenian = "lang_sl"
    Spanish = "lang_es"
    Swahili = "lang_sw"
    Swedish = "lang_sv"
    Thai = "lang_th"
    Turkish = "lang_tr"
    Ukrainian = "lang_uk"
    Vietnamese = "lang_vi"


class Regions(Enum):
    """Available regions."""

    Any = ""
    Afghanistan = "countryAF"
    Albania = "countryAL"
    Algeria = "countryDZ"
    AmericanSamoa = "countryAS"
    Andorra = "countryAD"
    Angola = "countryAO"
    Anguilla = "countryAI"
    Antarctica = "countryAQ"
    AntiguaAndBarbuda = "countryAG"
    Argentina = "countryAR"
    Armenia = "countryAM"
    Aruba = "countryAW"
    Australia = "countryAU"
    Austria = "countryAT"
    Azerbaijan = "countryAZ"
    Bahamas = "countryBS"
    Bahrain = "countryBH"
    Bangladesh = "countryBD"
    Barbados = "countryBB"
    Belarus = "countryBY"
    Belgium = "countryBE"
    Belize = "countryBZ"
    Benin = "countryBJ"
    Bermuda = "countryBM"
    Bhutan = "countryBT"
    Bolivia = "countryBO"
    BosniaAndHerzegovina = "countryBA"
    Botswana = "countryBW"
    BouvetIsland = "countryBV"
    Brazil = "countryBR"
    BritishIndianOceanTerritory = "countryIO"
    BritishVirginIslands = "countryVG"
    Brunei = "countryBN"
    Bulgaria = "countryBG"
    BurkinaFaso = "countryBF"
    Burundi = "countryBI"
    Cambodia = "countryKH"
    Cameroon = "countryCM"
    Canada = "countryCA"
    CapeVerde = "countryCV"
    CaymanIslands = "countryKY"
    CentralAfricanRepublic = "countryCF"
    Chad = "countryTD"
    Chile = "countryCL"
    China = "countryCN"
    ChristmasIsland = "countryCX"
    CocosIslands = "countryCC"
    Colombia = "countryCO"
    Comoros = "countryKM"
    CongoBrazzaville = "countryCG"
    CongoKinshasa = "countryCD"
    CookIslands = "countryCK"
    CostaRica = "countryCR"
    CoteIvoire = "countryCI"
    Croatia = "countryHR"
    Cuba = "countryCU"
    Cyprus = "countryCY"
    Czechia = "countryCZ"
    Denmark = "countryDK"
    Djibouti = "countryDJ"
    Dominica = "countryDM"
    DominicanRepublic = "countryDO"
    Ecuador = "countryEC"
    Egypt = "countryEG"
    ElSalvador = "countrySV"
    EquatorialGuinea = "countryGQ"
    Eritrea = "countryER"
    Estonia = "countryEE"
    Eswatini = "countrySZ"
    Ethiopia = "countryET"
    FalklandIslands = "countryFK"
    FaroeIslands = "countryFO"
    Fiji = "countryFJ"
    Finland = "countryFI"
    France = "countryFR"
    FrenchGuiana = "countryGF"
    FrenchPolynesia = "countryPF"
    FrenchSouthernTerritories = "countryTF"
    Gabon = "countryGA"
    Gambia = "countryGM"
    Georgia = "countryGE"
    Germany = "countryDE"
    Ghana = "countryGH"
    Gibraltar = "countryGI"
    Greece = "countryGR"
    Greenland = "countryGL"
    Grenada = "countryGD"
    Guadeloupe = "countryGP"
    Guam = "countryGU"
    Guatemala = "countryGT"
    Guinea = "countryGN"
    GuineaBissau = "countryGW"
    Guyana = "countryGY"
    Haiti = "countryHT"
    HeardAndMcDonaldIslands = "countryHM"
    Honduras = "countryHN"
    HongKong = "countryHK"
    Hungary = "countryHU"
    Iceland = "countryIS"
    India = "countryIN"
    Indonesia = "countryID"
    Iran = "countryIR"
    Iraq = "countryIQ"
    Ireland = "countryIE"
    Israel = "countryIL"
    Italy = "countryIT"
    Jamaica = "countryJM"
    Japan = "countryJP"
    Jordan = "countryJO"
    Kazakhstan = "countryKZ"
    Kenya = "countryKE"
    Kiribati = "countryKI"
    Kuwait = "countryKW"
    Kyrgyzstan = "countryKG"
    Laos = "countryLA"
    Latvia = "countryLV"
    Lebanon = "countryLB"
    Lesotho = "countryLS"
    Liberia = "countryLR"
    Libya = "countryLY"
    Liechtenstein = "countryLI"
    Lithuania = "countryLT"
    Luxembourg = "countryLU"
    Macao = "countryMO"
    Madagascar = "countryMG"
    Malawi = "countryMW"
    Malaysia = "countryMY"
    Maldives = "countryMV"
    Mali = "countryML"
    Malta = "countryMT"
    MarshallIslands = "countryMH"
    Martinique = "countryMQ"
    Mauritania = "countryMR"
    Mauritius = "countryMU"
    Mayotte = "countryYT"
    Mexico = "countryMX"
    Micronesia = "countryFM"
    Moldova = "countryMD"
    Monaco = "countryMC"
    Mongolia = "countryMN"
    Montserrat = "countryMS"
    Morocco = "countryMA"
    Mozambique = "countryMZ"
    Myanmar = "countryMM"
    Namibia = "countryNA"
    Nauru = "countryNR"
    Nepal = "countryNP"
    Netherlands = "countryNL"
    NewCaledonia = "countryNC"
    NewZealand = "countryNZ"
    Nicaragua = "countryNI"
    Niger = "countryNE"
    Nigeria = "countryNG"
    Niue = "countryNU"
    NorfolkIsland = "countryNF"
    NorthKorea = "countryKP"
    NorthMacedonia = "countryMK"
    NorthernMarianaIslands = "countryMP"
    Norway = "countryNO"
    Oman = "countryOM"
    Pakistan = "countryPK"
    Palau = "countryPW"
    Palestine = "countryPS"
    Panama = "countryPA"
    PapuaNewGuinea = "countryPG"
    Paraguay = "countryPY"
    Peru = "countryPE"
    Philippines = "countryPH"
    PitcairnIslands = "countryPN"
    Poland = "countryPL"
    Portugal = "countryPT"
    PuertoRico = "countryPR"
    Qatar = "countryQA"
    Reunion = "countryRE"
    Romania = "countryRO"
    Russia = "countryRU"
    Rwanda = "countryRW"
    Samoa = "countryWS"
    SanMarino = "countrySM"
    SaoTomeAndPrincipe = "countryST"
    SaudiArabia = "countrySA"
    Senegal = "countrySN"
    Serbia = "countryRS"
    Seychelles = "countrySC"
    SierraLeone = "countrySL"
    Singapore = "countrySG"
    Slovakia = "countrySK"
    Slovenia = "countrySI"
    SolomonIslands = "countrySB"
    Somalia = "countrySO"
    SouthAfrica = "countryZA"
    SouthGeorgiaAndSouthSandwichIslands = "countryGS"
    SouthKorea = "countryKR"
    Spain = "countryES"
    SriLanka = "countryLK"
    StHelena = "countrySH"
    StKittsAndNevis = "countryKN"
    StLucia = "countryLC"
    StPierreAndMiquelon = "countryPM"
    StVincentAndGrenadines = "countryVC"
    Sudan = "countrySD"
    Suriname = "countrySR"
    SvalbardAndJanMayen = "countrySJ"
    Sweden = "countrySE"
    Switzerland = "countryCH"
    Syria = "countrySY"
    Taiwan = "countryTW"
    Tajikistan = "countryTJ"
    Tanzania = "countryTZ"
    Thailand = "countryTH"
    Togo = "countryTG"
    Tokelau = "countryTK"
    Tonga = "countryTO"
    TrinidadAndTobago = "countryTT"
    Tunisia = "countryTN"
    Turkiye = "countryTR"
    Turkmenistan = "countryTM"
    TurksAndCaicosIslands = "countryTC"
    Tuvalu = "countryTV"
    USOutlyingIslands = "countryUM"
    USVirginIslands = "countryVI"
    Uganda = "countryUG"
    Ukraine = "countryUA"
    UnitedArabEmirates = "countryAE"
    UnitedKingdom = "countryGB"
    UnitedStates = "countryUS"
    Uruguay = "countryUY"
    Uzbekistan = "countryUZ"
    Vanuatu = "countryVU"
    VaticanCity = "countryVA"
    Venezuela = "countryVE"
    Vietnam = "countryVN"
    WallisAndFutuna = "countryWF"
    WesterSahara = "countryEH"
    Yemen = "countryYE"
    Zambia = "countryZM"
    Zimbabwe = "countryZW"


class LastUpdate(Enum):
    """Last update options."""

    Anytime = "all"
    Past24Hours = "d"
    PastWeek = "w"
    PastMonth = "m"
    PastYear = "y"


class TermsAppearing(Enum):
    """Where should terms appear."""

    Anywhere = "any"
    PageTitle = "title"
    PageText = "body"
    PageURL = "url"
    PageLinks = "links"


class FileTypes(Enum):
    """Available file types."""

    Any = ""
    AdobeAcrobatPDF = "pdf"
    AdobePostscript = "ps"
    AutodeskDWF = "dwf"
    GoogleEarthKML = "kml"
    GoogleEarthKMZ = "kmz"
    Excel = "xls"
    PowerPoint = "ppt"
    Word = "doc"
    RichTextFormat = "rtf"
    ShockwaveFlash = "swf"


class UsageRights(Enum):
    """Available usage rights options."""

    NotFilteredByLicence = ""
    UseOrShare = "f"
    UseOrShareEvenCommercially = "fc"
    UseShareOrModify = "fm"
    UseShareOrModifyEvenCommercially = "fmc"